'Pokojowy termometr z higrometrem
'Projekt wykona Krzysztof Goka
$regfile = "m8def.dat"
$crystal = 4000000
Config Portd = 255
        Portd = 255
Config Portb = 255
        Portb = 255
Config Portc = 255
        Portc = 255
Config Timer0 = Timer , Prescale = 1024
On Timer0 Przerwanie
Enable Interrupts
Enable Timer0
Load Timer0 , 37
Kierunek Alias Ddrc.1
Wyjscie Alias Portc.1
Wejscie Alias Pinc.1
Wz1 Alias Portd.1
Wz2 Alias Portd.5
Wc1 Alias Portd.2
Wc2 Alias Portd.6
Dim A As Byte
Dim B As Byte
Dim Suma As Byte
Dim Temperatura As Byte
Dim Wilgotnosc As Byte
Dim Bitt As Byte
Dim Bajt As Byte
Dim Crc As Byte
Dim Linia As Bit
Dim Wyswietlane As Bit
Dim Blad As Bit
Wyswietlane = 0
Set Kierunek
Set Wyjscie

Do
  Blad = 0
  Gosub Pomiar
  Toggle Wyswietlane
  If Blad = 0 Then
    If Wyswietlane = 0 Then
      A = Makebcd(temperatura)
      B = A And &B00001111
      Shift A , Right , 4
    Else
      A = Makebcd(wilgotnosc)
      B = A And &B00001111
      Shift A , Right , 4
    End If
  End If
  Waitms 1700
Loop
End

Przerwanie:
  Load Timer0 , 37
  Set Wz2
  Set Wz1
  Set Wc2
  Set Wc1

  If Wyswietlane = 0 Then
    If Linia = 0 Then
      Portb = Lookup(a , Tablica)
      If A = 0 Or A = 1 Or A = 7 Then
        Set Portd.7
      Else
        Reset Portd.7
      End If
      Reset Wz1
    End If
    If Linia = 1 Then
      Portb = Lookup(b , Tablica)
      If B = 0 Or B = 1 Or B = 7 Then
        Set Portd.7
      Else
        Reset Portd.7
      End If
      Reset Wz2
    End If
  Else
    If Linia = 0 Then
      Portb = Lookup(a , Tablica)
      If A = 0 Or A = 1 Or A = 7 Then
        Set Portd.7
      Else
        Reset Portd.7
      End If
      Reset Wc1
    End If
    If Linia = 1 Then
      Portb = Lookup(b , Tablica)
      If B = 0 Or B = 1 Or B = 7 Then
        Set Portd.7
      Else
        Reset Portd.7
      End If
      Reset Wc2
    End If
  End If
  Toggle Linia
Return

Pomiar:
  Set Kierunek
  Reset Wyjscie
  Waitms 30
  Set Wyjscie
  Disable Timer0
  Waitus 40
  Reset Kierunek
  Waitus 25
  If Wejscie = 1 Then
    Blad = 1
    Return
  End If
  Waitus 40
  If Wejscie = 0 Then
    Blad = 1
    Return
  End If
  While Wejscie = 1
  Wend
  Bitt = 0
  Bajt = 1
  Do
    For Bitt = 7 To 0 Step -1
      While Wejscie = 0
      Wend
      Waitus 35
      If Bajt = 1 Then
        If Wejscie = 1 Then
          Temperatura.bitt = 1
          While Wejscie = 1
          Wend
        Else
          Temperatura.bitt = 0
        End If
      End If
      If Bajt = 3 Then
        If Wejscie = 1 Then
          Wilgotnosc.bitt = 1
          While Wejscie = 1
          Wend
        Else
          Wilgotnosc.bitt = 0
        End If
      End If
      If Bajt = 5 Then
        If Wejscie = 1 Then
          Crc.bitt = 1
          While Wejscie = 1
          Wend
        Else
          Crc.bitt = 0
        End If
      End If
    Next Bitt
    Incr Bajt
  Loop Until Bajt = 6
  Enable Timer0
  Waitus 60
  Set Kierunek
  Set Wyjscie
  Suma = Temperatura + Wilgotnosc
  If Crc <> Suma Then
    Blad = 1
  End If
Return

Tablica:
  Data 0 , 53 , 9 , 33 , 52 , 34 , 2 , 49 , 0 , 32